<?php

namespace Drupal\ipstack\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\ipstack\Ipstack;

/**
 * Configure ipstack settings for this site.
 */
class IpstackTestForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ipstack_admin_test';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $user_ip =  \Drupal::request()->getClientIp();

    $form['ip'] = [
      '#type' => 'textfield',
      '#title' => $this->t('IP address'),
      '#default_value' => $user_ip,
      '#required' => TRUE,
      '#description' => t("IP address for test retrieving
        <a href='@url' rel='nofollow' target='_new'>ipstack.com</a> data.",
        ['@url' => 'https://ipstack.com']
    ),

    ];

    $form['actions'] = ['#type' => 'actions'];
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Test'),
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $ip = $form_state->getValue('ip');

    $ipstack = new Ipstack($ip);
    $url = $ipstack->getUrl();
    $data = $ipstack->getData();

    $msg = $this->t("Request: <a href='@url' target='_new'>@url</a>", ['@url' => $url]);
    drupal_set_message($msg);
    $msg = $data ? 'Data: ' . print_r($data, 1) : t('No data');
    drupal_set_message($msg);
  }

}
